*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\DBFINC\\DBFINC.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Procedure Main()
*+               Procedure Search4Subject()
*+               Static Procedure DoSearchRelease()
*+               Static Procedure DoSearchSubject()
*+               Static Procedure TakeThis()
*+               Procedure ItemMark()
*+               Procedure UnMarkAll()
*+               Function ListView_GETSELECTIONMARK()
*+               Function ListView_GETNEXTITEM()
*+               Function ListView_GETSELECTEDCOUNT()
*+               Procedure DoFindWin()
*+               Function CRE_OUTLOOK()
*+               Function CRE_INDEX()
*+
*+       Tables: USE ( zDBF ) EXCLUSIVE CODEPAGE "DEWIN"
*+               USE OUTLOOK.DBF VIA "DBFCDX"
*+               USE (datei) ALIAS OUTLOOK EXCLUSIVE
*+               USE (cDBF) VIA "DBFCDX" EXCLUSIVE
*+
*+    Reformatted by Click! 2.05.36 on Nov-25-2020 at  6:50 am
*+
*+--------------------------------------------------------------------

#include "hmg.ch"
#include "common.ch"

#define LVIS_FOCUSED             0x1
#define LVIS_SELECTED            0x2
#define LVIS_CUT                 0x4
#define LVIS_DROPHILITED         0x8
#define LVIS_GLOW                0x10
#define LVIS_ACTIVATING          0x20
#define LVIS_OVERLAYMASK         0xf00
#define LVIS_STATEIMAGEMASK      0xF000

#define LVNI_SELECTED            0x02

#define LVM_FIRST                0x1000
#define LVM_GETSELECTEDCOUNT     (LVM_FIRST+50)
#define LVM_GETSELECTIONMARK     (LVM_FIRST+66)
#define LVM_GETNEXTITEM          (LVM_FIRST+12)

REQUEST DBFCDX

REQUEST HB_LANG_ES
REQUEST HB_LANG_EN
REQUEST HB_LANG_FR
REQUEST HB_LANG_PT
REQUEST HB_LANG_DEWIN
REQUEST HB_LANG_RUWIN
REQUEST HB_LANG_IT
REQUEST HB_LANG_PLWIN
REQUEST HB_LANG_EU
REQUEST HB_LANG_HR852
REQUEST HB_LANG_SLWIN
REQUEST HB_LANG_CSWIN

REQUEST HB_CODEPAGE_ESWIN
REQUEST HB_CODEPAGE_BGWIN
REQUEST HB_CODEPAGE_DEWIN
REQUEST HB_CODEPAGE_ELWIN
REQUEST HB_CODEPAGE_HUWIN
REQUEST HB_CODEPAGE_PLWIN
REQUEST HB_CODEPAGE_PT850
REQUEST HB_CODEPAGE_RU1251
REQUEST HB_CODEPAGE_SRWIN
REQUEST HB_CODEPAGE_SLWIN

MEMVAR _HMG_SYSDATA

*+--------------------------------------------------------------------
*+
*+    Procedure Main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Main

LOCAL aPOS := { 0, 0 }, aSize := { 1024, 768 }
LOCAL zDBF := "OUTLOOK.DBF"

   RDDSETDEFAULT( "DBFCDX" )

   SET MULTIPLE OFF
   SET EPOCH TO YEAR( DATE() ) - 50
   SET CENTURY ON
   //    SET BROWSESYNC ON  // NOT here

   hb_cdpSelect( "DEWIN" )                                            // ANSI Version
   hb_langSelect( "DE" )                                              // normal 2 Sign
   SET DATE GERMAN

   // create DBF
   IF !FILE( zDBF )
      CRE_OUTLOOK( zDBF )
   ENDIF

   // create Index
   IF FILE( STRTRAN( zDBF, ".DBF", ".CDX" ) )
      FERASE( STRTRAN( zDBF, ".DBF", ".CDX" ) )
   ENDIF
   IF !FILE( STRTRAN( zDBF, ".DBF", ".CDX" ) )
      CRE_INDEX( zDBF )
   ENDIF

   // Office COM seems to use ANSI not UTF8
   USE ( zDBF ) EXCLUSIVE CODEPAGE "DEWIN"
   SET INDEX TO ( STRTRAN( zDBF, ".DBF", ".CDX" ) )
   ORDSETFOCUS( "SUBJECT" )
   // NOW set BROWSESYNC ON
   SET BROWSESYNC ON                                                  // MUST set ON

   DEFINE WINDOW Form_1 ;
         AT aPos[ 1 ], aPos[ 2 ] ;
         WIDTH aSize[ 1 ] ;
         HEIGHT aSize[ 2 ] ;
         TITLE 'Search in DBF increment' ;
         ICON nil ;
         FONT "Arial" SIZE 10 ;
         NOMAXIMIZE ;
         NOSIZE ;
         ON INIT nil ;
         ON RELEASE nil ;
         BACKCOLOR nil ;
         MAIN

      DEFINE MAIN MENU OF Form_1
         DEFINE POPUP "Do"
            MENUITEM "&Search" ACTION Search4Subject()
            SEPARATOR
            MENUITEM "&Exit" ACTION Form_1.RELEASE
         END POPUP
      END MENU
   END WINDOW

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Search4Subject()
*+
*+    Called from ( dbfinc.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Search4Subject()

LOCAL aHead     := { "Subject", "Location", "Date", "Time" }
LOCAL aWide     := { 300, 250, 100, 80 }
LOCAL aFeld     := { 'Subject', 'Location', "Startdate", "Starttime" }
LOCAL cWorkArea, lEdit := .F.
LOCAL aStruc

   IF IsWindowDefined( DDEdit )
      DoFindWin( "Incremental search in grid" )
   ELSE

      IF .NOT. USED()
         USE OUTLOOK.DBF VIA "DBFCDX"
         SET INDEX TO OUTLOOK.CDX
         ORDSETFOCUS( "SUBJECT" )
      ENDIF
      cWorkArea := ALIAS()

      // after open DBF set BROWSESYNC ON
      SET BROWSESYNC ON                                               // MUST set ON

      DEFINE WINDOW SearchForm ;
            AT 0, 0 ;
            WIDTH 800 ;
            HEIGHT 600 ;
            NOMAXIMIZE ;
            NOSIZE ;
            BACKCOLOR nil ;
            ON RELEASE DoSearchRelease() ;
            TITLE "Incremental search in grid" ;
            ICON "ICO_CAL_SEARCH"

         @ 10, 10 TEXTBOX SearchText ;
                 WIDTH 760 ;
                 HEIGHT 24 ;
                 FONT "Arial" ;
                 SIZE 10 ;
                 ToolTip "Search string" ;
                 ON CHANGE DoSearchSubject()

         DEFINE BROWSE SearchGrid
            PARENT "SearchForm"
            ROW 40
            COL 10
            WIDTH 760
            HEIGHT 500
            HEADERS aHead
            WIDTHS aWide
            WORKAREA &( cWorkArea )
            FIELDS aFeld
            VALUE RECCOUNT() + 1
            FONTNAME "Arial"
            FONTSIZE 10
            BACKCOLOR nil
            FONTCOLOR nil
            JUSTIFY { GRID_JTFY_LEFT, GRID_JTFY_LEFT, GRID_JTFY_LEFT, GRID_JTFY_LEFT }
            ONDBLCLICK TakeThis()
            TOOLTIP "type something into Textbox"
            // ALLOWAPPEND lEdit
            // ALLOWDELETE lEdit
            // LOCK IF( lEdit = .T., .T., .F. )
            // VSCROLLBAR .T.
            // NOLINES .F.
         END BROWSE
      END WINDOW

      ON KEY ESCAPE OF SearchForm ACTION Domethod( "SearchForm", "Release" )

      CENTER WINDOW SearchForm
      ACTIVATE WINDOW SearchForm

   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoSearchRelease()
*+
*+    Called from ( dbfinc.prg )   1 - procedure search4subject()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoSearchRelease()

   IF USED()
      CLOSE
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoSearchSubject()
*+
*+    Called from ( dbfinc.prg )   1 - procedure search4subject()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoSearchSubject()

LOCAL cSeek  := TRIM( SearchForm.SearchText.Value )
LOCAL nRecno := RECNO()
LOCAL hGrid

   SEEK( UPPER( cSeek ) )
   IF FOUND()
      nRecno := RECNO()
      Domethod( "SearchForm", "SearchGrid", "REFRESH" )

      // now geht Handle of BROWSE
      hGrid := GetControlHandle( "SearchGrid", "SearchForm" )
      // unmark 1st
      UnMarkAll( hGrid, .T. )
      // now set Value to GRID
      Setproperty( "SearchForm", "SearchGrid", "VALUE", nRecno  )
      // mark it and make it visible in BROWSE
      ItemMark( hGrid, nRecno )
   ELSE
      GOTO( nRecno )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure TakeThis()
*+
*+    Called from ( dbfinc.prg )   1 - procedure search4subject()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE TakeThis()

LOCAL nRecno := Getproperty( "SearchForm", "SearchGrid", "VALUE" )
LOCAL dDate

   GOTO( nRecno )
   dDate := OUTLOOK->STARTDATE
   Domethod( "SearchForm", "Release" )

   // Week5or7( 1 )      // switch View
   // GoToDate( dDate )  // Show Day
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure ItemMark()
*+
*+    Called from ( dbfinc.prg )   1 - static procedure dosearchsubject()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE ItemMark( hGrid, nPos, nState, nMask )

   DEFAULT nState TO hb_BitOr( LVIS_SELECTED, LVIS_FOCUSED )
   DEFAULT nMask TO hb_BitOr( LVIS_SELECTED, LVIS_FOCUSED )
   // this set "mark"
   LISTVIEW_SETITEMSTATE( hGrid, nPos, nState, nMask )
   // this bring Item into visible Position
   ListView_EnsureVisible( hGrid, nPos, .T. )
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure UnMarkAll()
*+
*+    Called from ( dbfinc.prg )   1 - static procedure dosearchsubject()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE UnMarkAll( hGrid, lAll )

LOCAL iMax
LOCAL nCount := 0
LOCAL nSel
LOCAL nState := hb_BitOr( LVIS_SELECTED, LVIS_FOCUSED )
LOCAL nMask  := hb_BitOr( LVIS_SELECTED, LVIS_FOCUSED )

   DEFAULT lAll TO .T.

   // unmark active Position !
   nSel := ListView_GetSelectionMark( hGrid )
   LISTVIEW_SETITEMSTATE( hGrid, nSel, 0, nMask )

   iMax := ListView_GetSelectedCount( hGrid )
   IF iMax > 0
      nSel := ListView_GetNextItem( hGrid, - 1, LVNI_SELECTED )
      LISTVIEW_SETITEMSTATE( hGrid, nSel, 0, nMask )

      DO WHILE .T.
         nSel := ListView_GetNextItem( hGrid, nSel, LVNI_SELECTED )
         nCount ++
         IF nSel > 0
            LISTVIEW_SETITEMSTATE( hGrid, nSel, 0, nMask )
         ELSE
            EXIT
         ENDIF
         IF nCount > iMax
            EXIT
         ENDIF
      ENDDO
   ENDIF

   DO EVENTS

RETURN

*+--------------------------------------------------------------------
*+
*+    Function ListView_GETSELECTIONMARK()
*+
*+    Called from ( dbfinc.prg )   1 - procedure unmarkall()
*+
*+--------------------------------------------------------------------
*+
FUNCTION ListView_Getselectionmark( hwndLV )

LOCAL nRet := 0
   nRet := SendMessage( hwndLV, LVM_GETSELECTIONMARK, 0, 0 )
RETURN nRet

*+--------------------------------------------------------------------
*+
*+    Function ListView_GETNEXTITEM()
*+
*+    Called from ( dbfinc.prg )   2 - procedure unmarkall()
*+
*+--------------------------------------------------------------------
*+
FUNCTION ListView_Getnextitem( hwndLV, nIndex )

LOCAL nRet := 0
   nRet := SendMessage( hwndLV, nIndex, LVNI_SELECTED, 0 )
RETURN nRet

*+--------------------------------------------------------------------
*+
*+    Function ListView_GETSELECTEDCOUNT()
*+
*+    Called from ( dbfinc.prg )   1 - procedure unmarkall()
*+
*+--------------------------------------------------------------------
*+
FUNCTION ListView_Getselectedcount( hwndLV )

LOCAL nRet := 0
   nRet := SendMessage( hwndLV, LVM_GETSELECTEDCOUNT, 0, 0 )
RETURN nRet

*+--------------------------------------------------------------------
*+
*+    Procedure DoFindWin()
*+
*+    Called from ( dbfinc.prg )   1 - procedure search4subject()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoFindWin( cTitle )

LOCAL hWndDlg
   IF hb_cdpSelect() = "UTF8"
      hWndDlg := HMG_CallDLL( "User32.dll",, "FindWindowW", 0, cTitle )
   ELSE
      hWndDlg := HMG_CallDLL( "User32.dll",, "FindWindowA", 0, cTitle )
   ENDIF

   IF !( hWndDlg == 0 )
      SetForegroundWindow( hWndDlg )
      BringWindowToTop( hWndDlg )
      ShowWindow( hWndDlg, 1 )
      UpdateWindow( hWndDlg )
      //      xSET_FOCUS( hWndDlg )
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Function CRE_OUTLOOK()
*+
*+    Called from ( dbfinc.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION CRE_OUTLOOK( datei, alias, id )

LOCAL p
LOCAL field_list := {}
LOCAL nButton

   IF VALTYPE( datei ) != "C"
      datei := "OUTLOOK.DBF"
   ENDIF
   IF VALTYPE( alias ) != "C"
      p := AT( ".", datei )
      alias := IF( p > 0, SUBSTR( datei, 1, p - 1 ), datei )
   ENDIF
   IF VALTYPE( id ) != "N"
      id := 0
   ENDIF
   SELECT ( id )
   IF !FILE( datei )
      AADD( field_list, { "EVENTID", "N", 7, 0 } )                    // 9.999.999 Item enough ?
      AADD( field_list, { "CREDATE", "C", 18, 0 } )                   // YYYYMMDDHHMMSS.ccc
      AADD( field_list, { "LASTDATE", "C", 18, 0 } )
      AADD( field_list, { "SUBJECT", "C", 100, 0 } )
      AADD( field_list, { "LOCATION", "C", 100, 0 } )
      AADD( field_list, { "STARTDATE", "D", 8, 0 } )
      AADD( field_list, { "STARTTIME", "C", 12, 0 } )
      AADD( field_list, { "DURATION", "N", 5, 0 } )
      AADD( field_list, { "ALLDAY", "L", 1, 0 } )
      AADD( field_list, { "LABELCOLOR", "C", 20, 0 } )
      AADD( field_list, { "PRIVATE", "N", 3, 0 } )
      AADD( field_list, { "MEETING", "N", 3, 0 } )
      AADD( field_list, { "REMINDER", "L", 1, 0 } )
      AADD( field_list, { "WARNTIME", "N", 3, 0 } )
      AADD( field_list, { "REMINDTIME", "N", 14, 0 } )
      AADD( field_list, { "IMPORTAN", "N", 3, 0 } )
      AADD( field_list, { "BUSYSTAT", "N", 3, 0 } )
      AADD( field_list, { "RECURREN", "N", 3, 0 } )                   // RecurrenceState only
      AADD( field_list, { "USER", "C", 20, 0 } )

      // just for mark Record as deleted
      //
      AADD( field_list, { "MARKDEL", "L", 1, 0 } )                    // is Record deleted

      // Memofields
      //
      AADD( field_list, { "MEMOTEXT", "M", 10, 0 } )

      DBCREATE( datei, field_list, "DBFCDX" )

      USE (datei) ALIAS OUTLOOK EXCLUSIVE
      APPEND BLANK

      REPLACE OUTLOOK->STARTDATE WITH DATE()
      REPLACE OUTLOOK->STARTTIME WITH "12:00:00"
      REPLACE OUTLOOK->EVENTID WITH - 1
      REPLACE OUTLOOK->SUBJECT WITH "hello world"
      REPLACE OUTLOOK->LOCATION WITH "Location"
      //       REPLACE OUTLOOK->LABELCOLOR WITH SP_mCATGREEN()
      REPLACE OUTLOOK->DURATION WITH 120
      REPLACE OUTLOOK->ALLDAY WITH .F.
      REPLACE OUTLOOK->REMINDER WITH .F.
      REPLACE OUTLOOK->RECURREN WITH 0
      REPLACE OUTLOOK->WARNTIME WITH 0
      REPLACE OUTLOOK->BUSYSTAT WITH 0
      REPLACE OUTLOOK->IMPORTAN WITH 0
      REPLACE OUTLOOK->MEETING WITH 0
      REPLACE OUTLOOK->PRIVATE WITH 0
      REPLACE OUTLOOK->MEMOTEXT WITH "Body Text"

      REPLACE OUTLOOK->CREDATE WITH DTOS( DATE() ) + "120000"
      REPLACE OUTLOOK->LASTDATE WITH DTOS( DATE() ) + "120000"

      REPLACE OUTLOOK->USER WITH NETNAME()

      //       IF Sp_lUseLauf()
      //          REPLACE OUTLOOK->USER WITH XF_NETNAME()
      //       ELSE
      //          REPLACE OUTLOOK->USER WITH "LOKAL"
      //       ENDIF

      CLOSE
   ENDIF
RETURN .T.

*+--------------------------------------------------------------------
*+
*+    Function CRE_INDEX()
*+
*+    Called from ( dbfinc.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION CRE_INDEX( cDBF )

LOCAL _tagname
LOCAL _keyfeld
LOCAL _cdxname

   _cdxname := STRTRAN( cDBF, ".DBF", ".CDX" )

   USE (cDBF) VIA "DBFCDX" EXCLUSIVE
   //   PACK

   _tagname := "STARTDATE"
   _KEYFELD := "DTOS(Startdate)+SUBSTR(Starttime,1,2)+SUBSTR(Starttime,4,2)+SUBSTR(Starttime,7,2)"
   ORDCONDSET( ".NOT. MARKDEL = .T." )
   ORDCREATE( _cdxname, _tagname, _keyfeld )
   CLOSE INDEX

   _tagname := "CREATEDATE"
   _KEYFELD := "CREDATE+DTOS(Startdate)+SUBSTR(Starttime,1,2)+SUBSTR(Starttime,4,2)+SUBSTR(Starttime,7,2)"
   ORDCONDSET( ".NOT. MARKDEL = .T." )
   ORDCREATE( _cdxname, _tagname, _keyfeld )
   CLOSE INDEX

   _tagname := "LASTDATE"
   _KEYFELD := "LASTDATE+DTOS(Startdate)+SUBSTR(Starttime,1,2)+SUBSTR(Starttime,4,2)+SUBSTR(Starttime,7,2)"
   ORDCONDSET( ".NOT. MARKDEL = .T." )
   ORDCREATE( _cdxname, _tagname, _keyfeld )
   CLOSE INDEX

   _tagname := "SUBJECT"
   _KEYFELD := "UPPER(SUBJECT)"
   ORDCONDSET( ".NOT. MARKDEL = .T." )
   ORDCREATE( _cdxname, _tagname, _keyfeld )
   CLOSE INDEX

   _tagname := "ALLDAY"
   _KEYFELD := "IF(ALLDAY,'J','N')+UPPER(SUBJECT)"
   ORDCREATE( _cdxname, _tagname, _keyfeld )
   CLOSE INDEX

   // index on "markdel" Flag to "recycle" Records
   //
   _tagname := "MARKDEL"
   _KEYFELD := "IF( MARKDEL = .T., 'J', 'N' )"
   ORDCREATE( _cdxname, _tagname, _keyfeld )
   CLOSE INDEX

   CLOSE

RETURN ( .T. )

//
//
//

*+ EOF: DBFINC.PRG